;----------------------------------------;
; SetResolution, Ver. 2.0, Paul Brennick ;
; Concept & Original Code - CycleSaddles ;
; Portions of this code from TheXROOster ;
;----------------------------------------;
    .386
    .model  flat, stdcall
    option  casemap :none

    include \GeneSys\include\Windows.inc
    include \GeneSys\macros\macros.asm
    uselib  user32,kernel32,shell32,gdi32

SpecialProc PROTO  :DWORD, :DWORD, :DWORD, :DWORD

.const
;---------------------------------------
WM_SHELLNOTIFY      equ WM_USER+5
IDI_TRAY            equ 0
IDM_RESTORE         equ 8000
IDM_ABOUTIT         equ 8013
IDM_EXIT            equ 8010
IDM_GOOGLE          equ 8011
IDM_MASM32          equ 8012
IDM_RES1            equ 8013
IDM_RES2            equ 8014

IDI_ICON1           equ 500
IDC_RBN1            equ 1001
IDC_RBN2            equ 1002
IDC_SWITCH          equ 1003
IDC_TITLE_1         equ 4001
IDC_CLOSE           equ 4002
IDC_EXIT            equ 4003

DM_BITSPERPEL       equ 40000h
DM_PELSWIDTH        equ 80000h
DM_PELSHEIGHT       equ 100000h
DM_DISPLAYFLAGS     equ 200000h
DM_DISPLAYFREQUENCY equ 400000h

.data
;---------------------------------------
szFontName      db  "MS Sans Serif", 0
DlgMain         db  "Special", 0

MouseOverMsg    db  "Click Icon To Show Dialog", 0
Restore         db  "&Restore", 0
Google          db  "&Visit Google", 0
MASM32          db  "&Visit The MASM32 MessageBoard", 0
SetRes1024      db  "Set Resolution - 1024x768", 0
SetRes1280      db  "Set Resolution - 1280x1024", 0
AbtString       db  "&About", 0
Close           db  "&Exit", 0
GoogleSite      db  "http://www.google.com/", 0 ; Url For Google.com's Homepage
MASM32Site      db  "http://www.masm32.com/board/index.php", 0  ; Url For The MASM32 Homepage
MsgBoxCaption   db  "About", 0                                  ; About msgbox Caption
MsgBoxText      db  "Set Resolution Utility, v2.0", 10, 13      ; About msgbox Text
                db  "     by: Paul E. Brennick", 0
szBrowser       db  "iexplore.exe", 0

.data?
;---------------------------------------
hInstance   dd  ?
hIcon       dd  ?
hFont1      dd  ?
hWnd01      dd  ?
hWnd02      dd  ?
hPopupMenu  dd  ?                       ; Add this for tray icon menu

resolution  DEVMODE <>
icodat      NOTIFYICONDATA <>           ; This deals with the icon and icon status

.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     hInstance, eax
    invoke  DialogBoxParam, hInstance, addr DlgMain, 0, addr SpecialProc, 0
    invoke  ExitProcess, eax

SpecialProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    LOCAL pt:POINT

    mov eax,uMsg
    .if eax == WM_INITDIALOG
      invoke  CreatePopupMenu
      mov     hPopupMenu, eax
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_MASM32, addr MASM32
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_GOOGLE, addr Google
      invoke  AppendMenu, hPopupMenu, MF_SEPARATOR, -1, 0
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_RES1, addr SetRes1024
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_RES2, addr SetRes1280
      invoke  AppendMenu, hPopupMenu, MF_SEPARATOR, -1, 0
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_RESTORE, addr Restore
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_ABOUTIT, addr AbtString
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_EXIT, addr Close
      invoke  LoadIcon,hInstance, IDI_ICON1
      mov     hIcon, eax
      invoke  SendMessage, hWnd, WM_SETICON, 1, hIcon
      invoke  CreateFont, 24, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, addr szFontName
      mov     hFont1, eax
      invoke  SendDlgItemMessage, hWnd, IDC_TITLE_1, WM_SETFONT, hFont1, 0
      invoke  GetDlgItem, hWnd, IDC_RBN1
      mov     hWnd01, eax
      invoke  GetDlgItem, hWnd, IDC_RBN2
      mov     hWnd02, eax
      invoke  SendMessage, hWnd01, BM_SETCHECK, BST_CHECKED, 0
      invoke  SendMessage, hWnd02, BM_SETCHECK, BST_UNCHECKED, 0
    .elseif uMsg==WM_DESTROY
      invoke  DestroyMenu, hPopupMenu   ; Unload the Menu from menory
      invoke  DestroyIcon, hIcon        ; Unload Icon from memory
      invoke  Shell_NotifyIcon, NIM_DELETE, addr icodat ; Remove Tray Icon
      invoke  PostQuitMessage, NULL
    .elseif uMsg == WM_COMMAND
      mov     eax, wParam
      .if eax == IDC_SWITCH
        invoke  SendMessage, hWnd01, BM_GETSTATE, 0, 0
        .if eax == BST_CHECKED
          mov     resolution.dmFields,DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or \
                  DM_DISPLAYFLAGS or DM_DISPLAYFREQUENCY
          mov     resolution.dmBitsPerPel, 32           ; Color bits
          mov     resolution.dmPelsWidth, 1024          ; X pixel width 
          mov     resolution.dmPelsHeight, 768          ; Y pixel height 
          mov     resolution.dmDisplayFlags, 0          ; Display mode noninterlaced
          mov     resolution.dmDisplayFrequency, 85     ; Monitor Display Frequency
          mov     resolution.dmSize, sizeof resolution  ; Size of resolution structure
          invoke  ChangeDisplaySettings, addr resolution, 0
        .else
          mov     resolution.dmFields,DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or \
                  DM_DISPLAYFLAGS or DM_DISPLAYFREQUENCY
          mov     resolution.dmBitsPerPel, 32           ; Color bits
          mov     resolution.dmPelsWidth,1280           ; X pixel width 
          mov     resolution.dmPelsHeight, 1024         ; Y pixel height 
          mov     resolution.dmDisplayFlags, 0          ; Display mode noninterlaced
          mov     resolution.dmDisplayFrequency, 60     ; Monitor Display Frequency
          mov     resolution.dmSize, sizeof resolution  ; Size of resolution structure
          invoke  ChangeDisplaySettings, addr resolution, 0
        .endif
      .elseif eax == IDM_RES1
        mov     resolution.dmFields,DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or \
                DM_DISPLAYFLAGS or DM_DISPLAYFREQUENCY
        mov     resolution.dmBitsPerPel, 32             ; Color bits
        mov     resolution.dmPelsWidth, 1024            ; X pixel width 
        mov     resolution.dmPelsHeight, 768            ; Y pixel height 
        mov     resolution.dmDisplayFlags, 0            ; Display mode noninterlaced
        mov     resolution.dmDisplayFrequency, 85       ; Monitor Display Frequency
        mov     resolution.dmSize, sizeof resolution    ; Size of resolution structure
        invoke  ChangeDisplaySettings, addr resolution, 0
      .elseif eax == IDM_RES2
        mov     resolution.dmFields,DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or \
                DM_DISPLAYFLAGS or DM_DISPLAYFREQUENCY
        mov     resolution.dmBitsPerPel, 32             ; Color bits
        mov     resolution.dmPelsWidth,1280             ; X pixel width 
        mov     resolution.dmPelsHeight, 1024           ; Y pixel height 
        mov     resolution.dmDisplayFlags, 0            ; Display mode noninterlaced
        mov     resolution.dmDisplayFrequency, 60       ; Monitor Display Frequency
        mov     resolution.dmSize, sizeof resolution    ; Size of resolution structure
        invoke  ChangeDisplaySettings, addr resolution, 0
      .elseif eax == IDM_GOOGLE         ; If Visit Google Menu Item Clicked
        invoke  ShellExecute, hWnd, NULL, addr szBrowser, addr GoogleSite, NULL, SW_SHOWNORMAL
      .elseif eax == IDM_RESTORE        ; If Restore Menu Item Clicked
        invoke  Shell_NotifyIcon, NIM_DELETE, addr icodat ; Remove Tray Icon
        invoke  ShowWindow,hWnd,SW_RESTORE
      .elseif eax == IDM_MASM32         ; If Visit MASM32 Menu Item Clicked
        invoke  ShellExecute, hWnd, NULL, addr szBrowser, addr MASM32Site, NULL, SW_SHOWNORMAL
      .elseif eax == IDM_EXIT || eax == IDC_EXIT
        invoke  DestroyWindow, hWnd     ; End Program
      .elseif eax == IDM_ABOUTIT        ; If About Menu Item Clicked
        invoke  MessageBox, NULL, addr MsgBoxText, addr MsgBoxCaption, MB_OK
      .elseif eax == IDC_CLOSE
        jmp     Tray
      .endif
    .elseif eax == WM_CLOSE
      invoke  DestroyWindow, hWnd       ; End Program
    .elseif uMsg==WM_SIZE               ; If Minimize button is pressed, it is handled here
      .if wParam == SIZE_MINIMIZED
        jmp     Tray                    ; Jump To Tray Processing
      .endif
    .elseif uMsg == WM_SHELLNOTIFY      ; Setting up The Tray Icon
      .if wParam == IDI_TRAY            ; If the following happens in the Tray...
        .if lParam == WM_RBUTTONDOWN    ; If Right Mouse button is pressed on the tray
          invoke  GetCursorPos, addr pt
          invoke  SetForegroundWindow, hWnd
          invoke  TrackPopupMenu, hPopupMenu, TPM_RIGHTALIGN or TPM_RIGHTBUTTON,
                  pt.x, pt.y, NULL, hWnd, NULL  ; Show menu
          invoke  PostMessage, hWnd, WM_NULL, 0, 0
        .elseif lParam == WM_LBUTTONDBLCLK  ; If Left Mouse Button Is Pressed on the tray
          invoke  SendMessage, hWnd, WM_COMMAND, IDM_RESTORE, 0 ; Restore Dialog
        .endif
      .endif
    .elseif uMsg == WM_CLOSE
      invoke  DestroyWindow, hWnd
    .endif
    xor     eax, eax
    ret
Tray:
    mov     icodat.cbSize, sizeof NOTIFYICONDATA
    push    hWnd
    pop     icodat.hwnd
    mov     icodat.uID, IDI_TRAY
    mov     icodat.uFlags, NIF_ICON+NIF_MESSAGE+NIF_TIP
    mov     icodat.uCallbackMessage, WM_SHELLNOTIFY
    invoke  LoadIcon, hInstance, IDI_ICON1                  ; This is where you define an icon
    mov     icodat.hIcon, eax
    invoke  lstrcpy, addr icodat.szTip, addr MouseOverMsg   ; Adding Msg to the tray
    invoke  ShowWindow, hWnd, SW_HIDE                       ; Hide the open Dialog
    invoke  Shell_NotifyIcon, NIM_ADD, addr icodat          ; Go To Tray
    ret
;---------------------------------------
SpecialProc endp

    end start
